var $ = function(aID) { return document.getElementById(aID); }

var photoAccountListing = {
    mApiMgr:null,
    mApiListener: null,
};

photoAccountListing.doSetup = function() {
    window.openDialog("chrome://browser/content/flock/photo/photoAccountWizard.xul", "wiz", "modal,centerscreen", $("account-menu").selectedItem.value);
    this.updateCommands();
    this.setupMenulist();
    this.setupAccountList();//refresh all the ui
}

photoAccountListing.updateCommands = function() {
    var menu = $("account-menu");
    if(!menu.selectedItem.value || !menu.selectedItem.value.length) {
        $("cmdDoSetup").setAttribute("disabled", true);
    }
    else {
        $("cmdDoSetup").setAttribute("disabled", false);
    }
    
    //$('photoAccountListing').getButton('accept').disabled =  this.hasLoggedInService() ? false : true;
}

photoAccountListing.deleteChildren = function (aElm) {
    var toDelete = new Array();
    for(var i=0;i<aElm.childNodes.length;++i) {
        var kid = aElm.childNodes.item(i);
        if(!kid.getAttribute("dontdelete")) {
            if (kid.localName == 'photoAccount')
                kid.removeListener();
            
             toDelete.push(kid);
        }
    }
    for(var i=0;i<toDelete.length;++i) {
        var kid = toDelete[i];
        kid.parentNode.removeChild(kid);
    }
}

photoAccountListing.setupMenulist = function() {
    var list = $("account-menu-popup");
    this.deleteChildren(list);
    
    var svcs = this.mApiMgr.services;
    while(svcs.hasMoreElements()) {
        var svc = svcs.getNext();
        var serviceName = svc.serviceName; if(!serviceName) continue;//tmp workaround
        var menuitem = document.createElement("menuitem");
        list.appendChild(menuitem);
        menuitem.value = svc.shortName;
        menuitem.setAttribute("label", svc.serviceName);
    }
}

photoAccountListing.getPreferredServices = function() {
    var rval = {};
    var preferredServices = this.mApiMgr.preferredServices;
    while(preferredServices.hasMoreElements()) {
        var svc = preferredServices.getNext();
        rval[svc.shortName] = svc;
    }
    return rval;
}

photoAccountListing.setupAccountList = function() {
    var preferredServices = this.getPreferredServices();
    var listing = $("listing");
    
    this.deleteChildren(listing);
    for(var p in preferredServices) {
        var svc = preferredServices[p];
        var serviceName = svc.serviceName; if(!serviceName) continue;//tmp workaround
        var account = document.createElement("photoAccount");
        account.service = svc;
        listing.appendChild(account);
    }
    
    if (!listing.childNodes.length) {
        var noAccountMsg = document.createElement('label');
        noAccountMsg.setAttribute('value', "No photo service accounts setup.");
        listing.appendChild(noAccountMsg);
    }
    
}

photoAccountListing.hasLoggedInService = function() {
      var preferredServices = this.getPreferredServices();
      for(var p in preferredServices) {
        var svc = preferredServices[p];
        if (svc.isLoggedIn)
            return true;
    }
    return false;
}

photoAccountListing.load = function() {
    this.mApiMgr = Components.classes['@flock.com/photo-api-manager;1?']
        .getService(Components.interfaces.flockIPhotoAPIManager);
    var inst = this;
    this.updateCommands();
    this.setupMenulist();
    this.setupAccountList();
    this.mApiListener = {
        onAPIStateChange: function(aAPI) {
            inst.updateCommands();
        },
        onError: function(aError) {
           alert(aError.errorString);
           inst.updateCommands();
        }
    }
    this.mApiMgr.addListener(this.mApiListener);
}

photoAccountListing.unload = function() {
    this.mApiMgr.removeListener(this.mApiListener);
    try {
        if (window.arguments[0] && window.arguments[0].hasValidSvc)
            window.arguments[0].hasValidSvc = photoAccountListing.hasLoggedInService();
    } catch (ex) {
        dump(ex + '\n');
    }
}
