// vim: foldmethod=marker
//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

var gPhotoUploader;
 
var uploadListener = {
    onUploadStart: function (aCurrentUpload, aCount, aMax) {
        var msg = "Uploading: " + aCurrentUpload.title;
        dump("UploadStart "+aCount+" "+aMax+"\n");
        // -1 because the current photo is not uploaded yet 
        var percent = ((aCount - 1)*100) / aMax;
        $('uploading-title').setAttribute("value", msg);
        $('upload-progressmeter').setAttribute("value", percent.toString()+"%");
    },
    onUpload: function (aCurrentUpload, aCount, aMax) {
    },
    onUploadAdd: function (aCurrentUpload) {
    },
    onUploadRemove: function () {
    },
    onUploadComplete: function () {
        $('upload-progressmeter').setAttribute("value", "100%");
        var showUploadedPics = flock_getBoolPref('flock.photo.uploader.showPhotosOnUpload');
        if (showUploadedPics) {
            var apimgr = Components.classes['@flock.com/photo-api-manager;1?'] 
                               .getService(Components.interfaces.flockIPhotoAPIManager);
            var authPerson = apimgr.getDefaultService().getAuthPerson();
            var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                       .getService(Components.interfaces.nsIWindowMediator);
            var win = wm.getMostRecentWindow('navigator:browser');
            
            if (win) {
                win.flock_topbarSelect(win.document.getElementById('flock_PhotoBrowseTopbarBroadcaster'), true);
                if (win.TopbarJSCtx().photoBrowser) win.TopbarJSCtx().photoBrowser.loadPersonPre(authPerson);
            }
        }
        gPhotoUploader.SVC.removeListener(this);
        window.setTimeout("close();", 500);
    },
    onUploadError: function (aUpload, aCount, aMax, aError) {
    },
    onAuthStateChange: function (aState) {
    }
}

function progress_onload() {
    var params = window.arguments[0];
    var apiName = params.apiName;
    var albumId = params.albumId;
    gPhotoUploader = params.photoUploader;
    var pendingUploads = gPhotoUploader.getAllPhotoUploads()

    // Add the listener giving feedback to the user on the status
    dump(">>>> Add the photo upload progress listener...\n");
    gPhotoUploader.SVC.addListener(uploadListener);

    // Add each photo to the uploader object
    dump("Add each photo to the uploader object\n");
    for (var i=0; i < pendingUploads.length; i++) {
        pendingUploads[i].album = params.albumId;
        gPhotoUploader.SVC.savePhotoUpload(pendingUploads[i]); 
    }
    // Actually upload the photos
    dump("Actually upload the photos\n");
    var apiMgr = Components.classes["@flock.com/photo-api-manager;1?"]
        .createInstance(Components.interfaces.flockIPhotoAPIManager);
    var api = apiMgr.getAPIFromShortname(params.apiName);
    gPhotoUploader.SVC.upload(api);
}


